#include <winsock2.h>
#include "cmsserverclass.h"

//#include <iostream>

//using namespace std;

//Adds a receiving socket to the list
int cmsserverclass::addsocket(SOCKET socket){
	//Create new socket-element
	CLIENT_SOCKETS *cs = new CLIENT_SOCKETS;
	cs->socket_id = next_socket_id++;
	cs->socket = socket;
	cs->dummy = 1;	//Dummy variable for the ioctlsocket()-command
	ioctlsocket(cs->socket, FIONBIO,(u_long *) &cs->dummy);	//Make socket non-blockable
	cs->next_client_socket = 0;
	cs->active = true;

	//Insert it into the list
	if ( first_client_socket == 0 ){
		first_client_socket = cs;
		client_sockets = cs;
		last_client_socket = cs;
	} else {
		last_client_socket->next_client_socket = cs;
		last_client_socket = cs;
	}

	return cs->socket_id;
}

//Removes a receving socket from the list
void cmsserverclass::remsocket(int socket_id){
	//Remove a connection from the list
/*
	CLIENT_SOCKETS *ctmpsock = first_client_socket;
	CLIENT_SOCKETS *clastsock = 0;

	while (ctmpsock != 0){
		if (ctmpsock->socket_id == socket_id){
			if (clastsock == 0){
				first_client_socket = first_client_socket->next_client_socket;
				if (first_client_socket == 0){
					client_sockets = 0;
					last_client_socket = 0;
				}
				delete ctmpsock;
				return;
			}
			else{
				clastsock->next_client_socket = ctmpsock->next_client_socket;
				if (client_sockets == ctmpsock) client_sockets = client_sockets->next_client_socket;
				delete ctmpsock;
				if (client_sockets == 0) last_client_socket = clastsock;
				return;
			}
		}

		clastsock = ctmpsock;
		ctmpsock = ctmpsock->next_client_socket;
	}
*/

	//hack to fix a problem temporarily: MEMLEAK!!
	first_client_socket = 0;	//"forget" existing sockets
	last_client_socket = 0;
	client_sockets = 0;

}

cmsserverclass::cmsserverclass(){
	cmsserverclass::listen_port = 2000;
	cmsserverclass::last_error = 0;
	cmsserverclass::last_error = WSAStartup( MAKEWORD(2,2), &(cmsserverclass::wsadata));
	cmsserverclass::client_sockets = NULL;
	cmsserverclass::last_client_socket = NULL;
	cmsserverclass::first_client_socket = 0;
	cmsserverclass::next_socket_id = 1;
}

cmsserverclass::cmsserverclass(int listen_port){
	cmsserverclass::listen_port = listen_port;
	cmsserverclass::last_error = 0;
	cmsserverclass::last_error = WSAStartup( MAKEWORD(2,2), &(cmsserverclass::wsadata));
	cmsserverclass::client_sockets = NULL;
	cmsserverclass::last_client_socket = NULL;
	cmsserverclass::first_client_socket = 0;
	cmsserverclass::next_socket_id = 1;
}

//Create a listening socket for the server
int cmsserverclass::connect(char *listenip){
	server_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

	dummy = 1;
	ioctlsocket(server_socket, FIONBIO,(u_long *) &dummy);

	server_service.sin_family = AF_INET;
	server_service.sin_addr.s_addr = inet_addr(listenip);
	server_service.sin_port = htons(listen_port);

	if (bind( server_socket, (SOCKADDR*) &(server_service), sizeof(server_service) ) == SOCKET_ERROR){
		last_error = WSAGetLastError();
		return last_error;
	}

	if (listen(server_socket, 1) == SOCKET_ERROR){
		last_error = WSAGetLastError();
		return last_error;
	}

	return 0;
}

//Check if there is any pending incoming sockets
int cmsserverclass::checkforconnection(){
	SOCKET AcceptSocket = SOCKET_ERROR;	//This is probably old remains not in use

	//Make sure accept won't block
/*	fd_set fds;
	fds.fd_array[0] = server_socket;
	fds.fd_count = 1;
	timeval t;
	t.tv_sec = 0;
	t.tv_usec = 0;
	int res = select(0, &fds, 0, 0, &t);

	//Accept won't block inside here
	if ((res != 0) && (res != SOCKET_ERROR)){
*/		AcceptSocket = accept( server_socket, NULL, NULL );
		last_error = WSAGetLastError();
		if (AcceptSocket != SOCKET_ERROR){
			return addsocket(AcceptSocket);
		}
//	}

	return 0;
}

//Check if there is data to be received in the incoming buffers for the current socket
int cmsserverclass::readConnection(char *buffer, int *buffer_size){
	
//	if (client_sockets == 0) client_sockets = first_client_socket;
//	else client_sockets = client_sockets->next_client_socket;

	client_sockets = first_client_socket;

	//Are there sockets to check?
	if (client_sockets != 0){

		//Make sure recv won't block
/*		fd_set fds;
		fds.fd_array[0] = client_sockets->socket;
		fds.fd_count = 1;
		timeval t;
		t.tv_sec = 0;
		t.tv_usec = 0;
		int res = select(0, &fds, 0, 0, &t);

		//recv won't block inside here
		if ((res != 0) && (res != SOCKET_ERROR)){
*/			*buffer_size = recv( client_sockets->socket, buffer, *buffer_size, 0 );
			if (*buffer_size == 0){
				int id = client_sockets->socket_id;
				shutdown(client_sockets->socket, SD_BOTH);
				closesocket(client_sockets->socket);
				remsocket(client_sockets->socket_id);
				*buffer_size = -1;
				return id;
			}
/*		} else {
			*buffer_size = 0;
			return 0;
		}
*/	}
	else{
		*buffer_size = 0;
		return 0;
	}
	
	if (*buffer_size > 0) return client_sockets->socket_id;

	*buffer_size = 0;
	return 0;
}

//Search for a particular socket
CLIENT_SOCKETS *cmsserverclass::findSocket(int socket_id){
	CLIENT_SOCKETS *csock = first_client_socket;

	while (csock != 0){
		if (csock->socket_id == socket_id) return csock;
		csock = csock->next_client_socket;
	}

	return 0;
}

//Write to a socket
int cmsserverclass::writeConnection(int socket_id, char *buffer, int buffer_size){

	CLIENT_SOCKETS *csock = findSocket(socket_id);

	if (csock != NULL){
		send(csock->socket, buffer, buffer_size, 0);
	}
	
	return 0;
}

//Return the last error value
int cmsserverclass::lerror(){
	return last_error;
}
