#include <fstream>

using namespace std;

typedef struct user{
	int id;
	char *name;
	char *password;
	char *savefilename;
	char *filename;
	char *orgname;
	char *orgid;
	ofstream *ofs;
	int fpos;
	long filesize;
	int logonstep;
	bool connected;
	bool validated;
	user *nextuser;
	char *fileid;
	bool closed;
} USER, *LPUSER;

class cmsusers{

private:
	LPUSER firstuser;
	LPUSER lastuser;
	int nextuserid;
	LPUSER userlist;
	char *basepath;

	LPUSER finduser(int id);
	int getszlength(char *instring);

public:

	cmsusers();
	~cmsusers();
	int adduser();
	int adduser(int id);
	int setname(int id, char *name);
	char *getname(int id);
	int setpassword(int id, char *password);
	char *getpassword(int id);
	char *createstring(char *instring);
	bool writefile(int id, char *buffer, int *size);
	bool userexists(int id);
	int setfilename(int id, char *name);
	char *getfilename(int id);
	char *getdbfilename(int id);
	void setvalidated(int id, bool validated);
	int getlogonstep(int id);
	void inclogonstep(int id);
	int setorgname(int id, char *name);
	int addtext(char *buffer, char *text2add, int pos);
	void endtext(char *buffer, int pos);
	char *getorgname(int id);
	void setbasepath(char *name);
	int setorgid(int id, char *name);
	char *getorgid(int id);
	void removeuser(int id);
	int setfileid(int id, char *name);
	char *getfileid(int id);
	void setclosed(int id);
	bool getclosed(int id);
};

