/*
 * This class handles networking and file transfer
 */

#include <winsock2.h>  //already included in windows.h
#include <iostream>
#include <fstream>

using namespace std;

//Helper functions to make temporar strings permanent
//TODO: clean up afterwards
static char *createstring(char *instring);	//Copy a string to a permanent location
static int getszlength(char *instring);		//Tell the size of a string, counts until 0x00 or 0x0a

/*
 * The class itself
 */

class shnetfile{

private:
	bool initialized;	//is networking is initialized?
	bool sendingfile;	//is there a request to send a file?
	bool fileopened;	//is the file to send opened?
	bool loggedon;		//are we logged on to the server?
	bool connected;		//are we connected to the server?
	char *serveraddress;
	char *serverport;
	char *username;
	char *password;
	char *filename;
	char *filepathname;
	long filesize;
	WSADATA w;
	int error;
	SOCKET s;
	sockaddr_in target;
	ifstream *ifs;
	char *buffer;

public:
	shnetfile();
	~shnetfile();

	bool shdoinitialize();	//initialize network subsystem
	bool shdodeinitialize();
	bool shdoconnect();		//connect to a server
	bool shdodisconnect();
	void shsetfilename(char *fn);	//set the name of the file to send
	void shsetfilepathname(char *fpn);	//set the name of the file to send
	char *shgetfilename();			//return it
	void shsetusername(char *un);
	void shsetpassword(char *pwd);
	void shsetserveraddress(char *sa);
	void shsetserverport(char *p);
	char *shgetserveraddress();
	char *shgetserverport();
	void shdosendfile();	//request to send a file
	bool issendingfile();	//test if a file is being sent
	bool shdosenddata();	//sends a portion of the file for each call
	bool shdoopenfile();	//opens a file for reading
	bool shdologon();		//logs on to a connected server

};
